/*
  *  BINtegrity aka Syswall
 *
 */

#ifndef __SYSWALL_MIPS_H__
#define __SYSWALL_MIPS_H__

#define HOOK(name) ref_sys_##name = (void *)sys_call_table[(__NR_##name - __NR_Linux) * 2]; sys_call_table[(__NR_##name - __NR_Linux) * 2] = (void *)sc_hook_##name;
#define UNHOOK(name) sys_call_table[(__NR_##name - __NR_Linux) * 2] = (unsigned *)ref_sys_##name;

#define KERNEL_BOUNDARY 0x80000000

#define ELF_READ_SIZE 200*1024

#define LINKER "ld-uClibc"
#define LINKER_LEN 9

#define SYSCALL_HOOK(name, level) \
    asmlinkage unsigned (*ref_sys_##name)(); \
    extern asmlinkage void sc_hook_##name(); \
    asm(".globl sc_hook_" #name       "\n" \
        "sc_hook_" #name ":"          "\n" \
        "addi $sp, $sp,  -0x48         \n" \
        "sw   $fp, 0x0($sp)            \n" \
        "sw   $ra, 0x4($sp)            \n" \
        "sw   $a0, 0x8($sp)            \n" \
        "sw   $a1, 0xc($sp)            \n" \
        "sw   $a2, 0x10($sp)           \n" \
        "sw   $a3, 0x14($sp)           \n" \
        "sw   $s0, 0x18($sp)           \n" \
        "sw   $s1, 0x1c($sp)           \n" \
        "sw   $s2, 0x20($sp)           \n" \
        "sw   $s3, 0x24($sp)           \n" \
        "sw   $s4, 0x28($sp)           \n" \
        "sw   $s5, 0x2c($sp)           \n" \
        "sw   $s6, 0x30($sp)           \n" \
        "sw   $s7, 0x34($sp)           \n" \
        "sw   $t5, 0x38($sp)           \n" \
        "sw   $t6, 0x3c($sp)           \n" \
        "sw   $gp, 0x40($sp)           \n" \
        "move $a0, $t5                 \n" \
        "move $a1, $t6                 \n" \
        "lw   $t0, chk_ptr" #name     "\n" \
        "jalr $t0                      \n" \
        "nop                           \n" \
        "lw   $fp, 0x0($sp)            \n" \
        "lw   $ra, 0x4($sp)            \n" \
        "lw   $a0, 0x8($sp)            \n" \
        "lw   $a1, 0xc($sp)            \n" \
        "lw   $a2, 0x10($sp)           \n" \
        "lw   $a3, 0x14($sp)           \n" \
        "lw   $s0, 0x18($sp)           \n" \
        "lw   $s1, 0x1c($sp)           \n" \
        "lw   $s2, 0x20($sp)           \n" \
        "lw   $s3, 0x24($sp)           \n" \
        "lw   $s4, 0x28($sp)           \n" \
        "lw   $s5, 0x2c($sp)           \n" \
        "lw   $s6, 0x30($sp)           \n" \
        "lw   $s7, 0x34($sp)           \n" \
        "lw   $t5, 0x38($sp)           \n" \
        "lw   $t6, 0x3c($sp)           \n" \
        "lw   $gp, 0x40($sp)           \n" \
        "lw   $t0, ref_ptr" #name     "\n" \
        "lw   $t0, ($t0)               \n" \
        "addi $sp, $sp,   0x48         \n" \
        "jr   $t0                      \n" \
        "nop                           \n" \
        "chk_ptr" #name ":"           "\n" \
        ".word check_syscall_" #level "\n" \
        "ref_ptr" #name ":"           "\n" \
        ".word ref_sys_" #name        "\n");

#define SYSCALL_HOOK_EXIT(name) \
    asmlinkage unsigned (*ref_sys_##name)(); \
    extern asmlinkage void sc_hook_##name(); \
    asm(".globl sc_hook_" #name       "\n" \
        "sc_hook_" #name ":"          "\n" \
        "addi $sp, $sp,  -0x48         \n" \
        "sw   $fp, 0x0($sp)            \n" \
        "sw   $ra, 0x4($sp)            \n" \
        "sw   $a0, 0x8($sp)            \n" \
        "sw   $a1, 0xc($sp)            \n" \
        "sw   $a2, 0x10($sp)           \n" \
        "sw   $a3, 0x14($sp)           \n" \
        "sw   $s0, 0x18($sp)           \n" \
        "sw   $s1, 0x1c($sp)           \n" \
        "sw   $s2, 0x20($sp)           \n" \
        "sw   $s3, 0x24($sp)           \n" \
        "sw   $s4, 0x28($sp)           \n" \
        "sw   $s5, 0x2c($sp)           \n" \
        "sw   $s6, 0x30($sp)           \n" \
        "sw   $s7, 0x34($sp)           \n" \
        "sw   $v0, 0x38($sp)           \n" \
        "sw   $v1, 0x3c($sp)           \n" \
        "sw   $gp, 0x40($sp)           \n" \
        "lw   $t0, chk_ptr" #name     "\n" \
        "jalr $t0                      \n" \
        "nop                           \n" \
        "lw   $fp, 0x0($sp)            \n" \
        "lw   $ra, 0x4($sp)            \n" \
        "lw   $a0, 0x8($sp)            \n" \
        "lw   $a1, 0xc($sp)            \n" \
        "lw   $a2, 0x10($sp)           \n" \
        "lw   $a3, 0x14($sp)           \n" \
        "lw   $s0, 0x18($sp)           \n" \
        "lw   $s1, 0x1c($sp)           \n" \
        "lw   $s2, 0x20($sp)           \n" \
        "lw   $s3, 0x24($sp)           \n" \
        "lw   $s4, 0x28($sp)           \n" \
        "lw   $s5, 0x2c($sp)           \n" \
        "lw   $s6, 0x30($sp)           \n" \
        "lw   $s7, 0x34($sp)           \n" \
        "lw   $v0, 0x38($sp)           \n" \
        "lw   $v1, 0x3c($sp)           \n" \
        "lw   $gp, 0x40($sp)           \n" \
        "lw   $t0, ref_ptr" #name     "\n" \
        "lw   $t0, ($t0)               \n" \
        "addi $sp, $sp,   0x48         \n" \
        "jr   $t0                      \n" \
        "nop                           \n" \
        "chk_ptr" #name ":"           "\n" \
        ".word check_exit              \n" \
        "ref_ptr" #name ":"           "\n" \
        ".word ref_sys_" #name        "\n");



#include "hooks.h"

#endif
